#!/usr/bin/python2

# $Id: insertPeers.py 97 2005-09-17 01:41:49Z mathias $

# Copyright (c) 2005 Mathias Gug
#
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation either version 2 of 
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA. 

import unittest
import httplib
from urllib import *
from BitTorrent import bencode
import MySQLdb
import sha
import Peer

class insertPeers(unittest.TestCase):

  def setUp(self):
    self.tracker_url = "drupal"
    self.announce_url = "bttracker/announce.php"
    self.conn = httplib.HTTPConnection(self.tracker_url)
    
    self.dbhost = "localhost"
    self.dbuser = "drupaluser"
    self.dbpass = "drupalp"
    self.dbname = "drupal"
    self.dbprfx = "dibitracker_"

    self.db = MySQLdb.connect(host=self.dbhost,user=self.dbuser,passwd=self.dbpass,db=self.dbname)
    self.dbcursor = self.db.cursor()

    self.torrent_file = { 'filename' : 'samba.tar.gz.torrent' }
    metainfo_file = open(self.torrent_file['filename'], 'rb')
    metainfo = bencode.bdecode(metainfo_file.read())
    metainfo_file.close()
    self.torrent_file['info'] = metainfo['info']
    self.torrent_file['info_hash'] = sha.new(bencode.bencode(self.torrent_file['info'])).digest()

    strQuery = """INSERT INTO %storrents SET info_hash='%s'""" % (self.dbprfx,self.torrent_file['info_hash'])
    self.dbcursor.execute(strQuery)

  def tearDown(self):
    self.conn.close()
    self.dbcursor.execute("DELETE FROM %storrents WHERE info_hash='%s'" % (self.dbprfx,self.torrent_file['info_hash']))
    self.dbcursor.execute("DELETE FROM %storrents_peers WHERE info_hash='%s'" % (self.dbprfx,self.torrent_file['info_hash']))
    self.dbcursor.execute("DELETE FROM %smembers_torrents_stats WHERE info_hash='%s'" % (self.dbprfx,self.torrent_file['info_hash']))
    self.dbcursor.close()
    self.db.close()

  def testInsertPeers(self):
    print "Inserting peers"
    nbpeers=10
    ps = Peer.PeerSet(nbpeers).getPeerSet()
    for p in ps:
      strRequest = "/%s?tuid=%s&info_hash=%s&peer_id=%s&ip=%s&port=%s&uploaded=%s&downloaded=%s&left=%s&event=%s" % (self.announce_url,p.tuid,quote(self.torrent_file['info_hash']),quote(p.peerid),p.ip,p.port,0,0,0,'completed')
      self.checkTrackerResponse(strRequest)
    raw_input("Peers registered")

  def checkTrackerResponse(self,strRequest):
    self.conn.request('GET',strRequest)
    res=bencode.bdecode(self.conn.getresponse().read())
    if res.has_key('failure reason'):
      self.fail("%s : %s" % (strRequest,res['failure reason']))
    return res

if __name__ == "__main__":
  unittest.main()
